#pragma once

#include "NPTimer.h"
#include <atlwin.h>
#include "Common.h"

class CNScrollBarTimer : public CWindowImpl<CNScrollBarTimer>
{
public:
	CNScrollBarTimer(void);
	~CNScrollBarTimer(void);

	/**
	* @brief				{kr}	Ÿ̸ Ŭ settingѴ. {/kr}
	* @param dwStartDueTime	{kr}	Timer  ð 帥 ۵ȴ. {/kr}
	* @param dwPeriod		{kr}	Timer  {/kr}
	* @param dwTid			{kr}	Timer ID {/kr}
	* @param pHandler		{kr}	ITimerHandler Ÿ̸Ӱ Ŀ ȣ ̽ {/kr}
	* @param flags			{kr}	flag {/kr}
	* @return				if this function succeeds, return TRUE
	*/
	BOOL SetTimer(DWORD dwStartDueTime, DWORD dwPeriod, DWORD dwTid, INPTimerHandler* pHandler, ULONG uFlag = 0);
	/**
	* @brief {kr} Ÿ̸ Ŭ stopѴ. {/kr}
	* @return				if this function succeeds, return TRUE
	*/
	BOOL StopTimer();
	/**
	* @brief 	{kr} Ÿ̸Ӱ ΰ?{/kr}
	*/
	BOOL IsRunning();

	/**
	* \brief {kr} Ÿ̸Ӱ Stop ɶ WM_TIMER ޽ ͸ ϸ鼭 ٸ. {/kr}
	*/
	void WaitForStop();
private:
	BOOL _Create();
	BOOL _Destroy();

	DWORD m_dwTimerID;
	INPTimerHandler* m_pTimerHandler;

	BEGIN_MSG_MAP(CNScrollBarTimer)
		MESSAGE_HANDLER(WM_TIMER, OnTimer)
	END_MSG_MAP()

	DECLARE_MESSAGE_HANDLER(OnTimer);
};
